/*	      nderung: Prescaler von 256 wird nun emuliert		            */

/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "rc5.h"

ISR(SIG_OVERFLOW0)
{

	if (cyclecount == 255)		// ersetzt Prescaler
	{
	  unsigned int tmp = rc5_tmp;				// for faster access

	  //TCNT0 = -2;					// 2 * 256 = 512 cycle
	  cyclecount = -2;
		
	  if( ++rc5_time > PULSE_MAX ){			// count pulse time
	    if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
	      rc5_data = tmp;
	    tmp = 0;
	  }

	  if( (rc5_bit ^ IR_PIN) & 1<<IR ){		// change detect
	    rc5_bit = ~rc5_bit;				// 0x00 -> 0xFF -> 0x00

	    if( rc5_time < PULSE_MIN )			// to short
	      tmp = 0;

	    if( !tmp || rc5_time > PULSE_1_2 ){		// start or long pulse time
	      if( !(tmp & 0x4000) )			// not to many bits
	        tmp <<= 1;				// shift
	      if( !(rc5_bit & 1<<IR) )		// inverted bit
	        tmp |= 1;				// insert new bit
	      rc5_time = 0;				// count next pulse time
	    }
	  }
	  rc5_tmp = tmp;
	}
	if (cyclecount != 255)
	{
		cyclecount++;
	}
}
